/* $Id: nibbler.js 12 2023-05-05 12:19:27Z nishi $ */
const username = document.getElementById("username");
const password = document.getElementById("password");
const version = document.getElementById("version").value;
const prefix = location.protocol + "//" + location.host + "/" + document.getElementById("prefix").value;
const scriptname = document.getElementById("prefix").value;
const msgs = document.getElementsByClassName("message-data");

if(msgs){
	([...msgs]).forEach(x=>{
			console.log(x.innerHTML);
			x.innerHTML = x.innerHTML.replace(/&gt;&gt;([0-9]+)/g, "<a href=\"#id$1\">&gt;&gt;$1</a>");
	});
}

if(localStorage.getItem("token")){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				localStorage.removeItem("token");
			}else{
				if(version[version.length - 1] == 'j'){
					document.getElementById("buttons").innerHTML = "<i>ユーザー「<code>" + result.username + "</code>」を使っています</i> <button id=\"logout-button\" onclick=\"nibbler_logout()\">ログアウト</button> <button id=\"new-thread-button\" onclick=\"location = '" + scriptname + "/new-thread'\">新規スレッド</button> <button id=\"jump-button\" onclick=\"location.hash = '#chat'\">チャット欄へ行く</button>";
				}else{
					document.getElementById("buttons").innerHTML = "<i>You are loginned as <code>" + result.username + "</code></i> <button id=\"logout-button\" onclick=\"nibbler_logout()\">Logout</button> <button id=\"new-thread-button\" onclick=\"location = '" + scriptname + "/new-thread'\">New Thread</button> <button id=\"jump-button\" onclick=\"location.hash = '#chat'\">Jump to the chat textarea</button>";
				}
				ready();
			}
		}
	};
	xhr.open("POST", prefix + "/v1/valid", true);
	xhr.send(localStorage.getItem("token"));
}

function nibbler_logout(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				localStorage.removeItem("token");
				location = prefix;
			}
		}
	};
	xhr.open("POST", prefix + "/v1/logout", true);
	xhr.send(localStorage.getItem("token"));
}

function nibbler_login(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				localStorage.setItem("token", result.token);
				location = prefix;
			}
		}
	};
	xhr.open("POST", prefix + "/v1/login", true);
	xhr.send(username.value + ":" + password.value);
}

function nibbler_signup(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				location = prefix;
			}
		}
	};
	xhr.open("POST", prefix + "/v1/signup", true);
	xhr.send(username.value + ":" + password.value);
}

function nibbler_new_thread(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				location = prefix + "/id/" + result.id;
			}
		}
	};
	xhr.open("POST", prefix + "/v1/thread/new", true);
	xhr.send(localStorage.getItem("token") + ":" + document.getElementById("genre-select").value + ":" + document.getElementById("thread-name").value);
}

function ready(){
	if(document.getElementById("chat")){
		document.getElementById("chat").value = "";
		document.getElementById("chat").disabled = false;
		document.getElementById("send-button").disabled = false;
		document.getElementById("chat").style.display = "inline";
		document.getElementById("send-button").style.display = "inline";
	}
}

function nibbler_send(){
	const xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(){
		if(this.readyState == 4){
			let result = JSON.parse(this.responseText);
			if(result.code != 0){
				alert("Error: " + result.error);
			}else{
				location.reload();
			}
		}
	};
	xhr.open("POST", prefix + "/v1/thread/send", true);
	xhr.send(localStorage.getItem("token") + ":" + document.getElementById("id").value + ":" + document.getElementById("chat").value);
}
