/* $Id: db.h 5 2023-05-05 09:48:02Z nishi $ */
#ifndef __NIBBLER_DB_H__
#define __NIBBLER_DB_H__

#include <ndbm.h>

#include <openssl/sha.h>

#include <stdint.h>
#include <time.h>

void nibbler_init_db();
DBM* nibbler_open_db(const char* path);
DBM* nibbler_check_db(const char* path);

enum DB_VALUE_TYPE {
	DB_TYPE_THREAD = 0,
	DB_TYPE_LENGTH,
	DB_TYPE_MESSAGE
};

struct nibbler_length {
	char type;
	uint64_t length;
};

struct nibbler_thread {
	char type;
	uint64_t id;
	char title[1025];
};

struct nibbler_message {
	char type;
	time_t time;
	uint64_t id;
};

struct nibbler_user {
	unsigned char password[SHA512_DIGEST_LENGTH];
	char mod;
};

#ifndef DB_SRC
extern DBM* nibbler_user_db;
extern DBM* nibbler_token_db;
#endif

#endif
