/* $Id: main.c 4 2023-05-05 05:34:27Z nishi $ */
#include <nibbler.h>

#include <nibbler/config.h>
#include <nibbler/page.h>
#include <nibbler/util.h>
#include <nibbler/db.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

int argc;
char** argv;
char* nibbler_body;

int main(int _argc, char** _argv){
	argc = _argc;
	argv = _argv;
	nibbler_body = malloc(1);
	nibbler_body[0] = 0;
	fseek(stdin, 0, SEEK_SET);
	char* buf = malloc(2);
	buf[1] = 0;
	int ch;
	if(!feof(stdin)){
		while((ch = fgetc(stdin)) != EOF){
			buf[0] = (char)ch;
			char* tmp = nibbler_body;
			nibbler_body = sstrcat(tmp, buf);
			free(tmp);
		}
	}
	free(buf);
	char* path;
	nibbler_init_db();
        char* replaced = strdup(getenv("PATH_INFO") == NULL ? "/" : getenv("PATH_INFO"));
        int i;
        for(i = 0; replaced[i] != 0; i++){
                if(replaced[i] == ' ') replaced[i] = '-';
        }
        if(replaced[strlen(replaced) - 1] == '/' && strcmp(replaced, "/") != 0) replaced[strlen(replaced) - 1] = 0;
        setenv("PATH_REPLACED", replaced, 1);
	char* str = getenv("PATH_REPLACED");
	char* result = malloc(1);
	result[0] = 0;
	int count = 0;
	buf = malloc(2);
	buf[1] = 0;
	for(i = 0; str[i] != 0; i++){
		buf[0] = str[i];
		if(str[i] == '/'){
			count++;
		}
		if(count == 0 || count == 1){
			char* tmp = result;
			result = sstrcat(tmp, buf);
			free(tmp);
		}
		if(count == 2) break;
	}
	free(buf);
        setenv("FIRST_PATH", result, 1);
	struct nibbler_config* config = nibbler_parse_config(NIBBLER_CONFIG);
	nibbler_read_genres(config);
	nibbler_page(config);
	nibbler_free_config(config);
}
